# SPDX-License-Identifier: GPL-2.0 OR BSD-2-Clause
%YAML 1.2
---
$id: http://devicetree.org/schemas/serial/xlnx,opb-uartlite.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: Xilinx Axi Uartlite

maintainers:
  - Peter Korsgaard <jacmet@sunsite.dk>

properties:
  compatible:
    contains:
      enum:
        - xlnx,xps-uartlite-1.00.a
        - xlnx,opb-uartlite-1.00.b

  reg:
    maxItems: 1

  interrupts:
    maxItems: 1

  port-number:
    $ref: /schemas/types.yaml#/definitions/uint32
    description: Set Uart port number

  clocks:
    maxItems: 1

  clock-names:
    const: s_axi_aclk

  current-speed:
    $ref: /schemas/types.yaml#/definitions/uint32
    description:
      The fixed baud rate that the device was configured for.

  xlnx,data-bits:
    enum: [5, 6, 7, 8]
    description:
      The fixed number of data bits that the device was configured for.

  xlnx,use-parity:
    $ref: /schemas/types.yaml#/definitions/uint32
    enum: [0, 1]
    description:
      Whether parity checking was enabled when the device was configured.

  xlnx,odd-parity:
    $ref: /schemas/types.yaml#/definitions/uint32
    enum: [0, 1]
    description:
      Whether odd parity was configured.

required:
  - compatible
  - reg
  - interrupts
  - current-speed
  - xlnx,data-bits
  - xlnx,use-parity

allOf:
  - $ref: /schemas/serial.yaml#
  - if:
      properties:
        xlnx,use-parity:
          const: 1
    then:
      required:
        - xlnx,odd-parity

unevaluatedProperties: false

examples:
  - |
      serial@800c0000 {
        compatible = "xlnx,xps-uartlite-1.00.a";
        reg = <0x800c0000 0x10000>;
        interrupts = <0x0 0x6e 0x1>;
        port-number = <0>;
        current-speed = <115200>;
        xlnx,data-bits = <8>;
        xlnx,use-parity = <0>;
      };
...
